# rdoc2dbk -- RDoc to DocBook
#
# $Date: 2002-09-26 22:09:10 -0400 (Thu, 26 Sep 2002) $
# $Rev: 60 $
# $Author: dblack $
#
# Very incomplete, may or may not be further developed.
#
# Reads STDIN
#
#
# David Black
# September 25, 2002

# Customize:
dtd = "/usr/local/sgml/docbkx412/docbookx.dtd"

def sect(level,switch=true)
  if switch then "<sect#{level}>" else "</sect#{level}>" end
end

def sect_range(n,m)
  (n..m).to_a.reverse.each {|level| puts sect(level,nil)}
end

def title(text)
  "<title>#{text}</title>"
end
  
oldlevel = -1
while (line = gets)
  if /^<\?xml version="1.0"/.match(line)
    print <<EOS
<?xml version="1.0"?>
<!DOCTYPE article SYSTEM "#{dtd}">
EOS
    discard = gets until /<\/p>/.match(discard)
  elsif /<\/description>/.match(line)
    discard = gets until /<\/rdoc>/.match(discard)
  elsif /^\s*<h(\d+)>\s*(.*)\s*<\/h\d>/.match(line)
    newlevel = $1.to_i - 1
    ttl = $2
    if newlevel == oldlevel
      puts sect(newlevel,nil)
    elsif newlevel < oldlevel
      sect_range(newlevel,oldlevel)
    end
    puts sect(newlevel)
    oldlevel = newlevel
    puts title(ttl)
  else
    print line
  end
end
sect_range(0,newlevel)
